import 'package:flutter/material.dart';

class Tile {
  Image image;
  Alignment alignment;


  Tile({required this.image, required this.alignment});

  Widget croppedImageTile(double widthFactor) {
    print("creating single tile");

    return FittedBox(
      fit: BoxFit.fill,
      child: ClipRect(
        child: Container(
          child: Align(
            alignment: this.alignment,
            widthFactor: widthFactor,
            heightFactor: widthFactor,
            child: image,
          ),
        ),
      ),
    );
  }
}

class Exo5 extends StatefulWidget {
  const Exo5({super.key});

  @override
  State<Exo5> createState() => _Exo5();
}

class _Exo5 extends State<Exo5> {
  final image = Image.network('https://picsum.photos/512');
  double? size = 300;
  int colNb = 3;

  @override
  Widget build(BuildContext context) {
    print("building state");


    return Scaffold(
      appBar: AppBar(
        title: const Text('Display a Tile as a Cropped Image'),
        centerTitle: true,
      ), 
      body:
        Column(
          children: [
            Text("col"),
            Container(
                margin: const EdgeInsets.all(20.0),
                child: GridView.count(
                    primary: false,
                    padding: const EdgeInsets.all(1),
                    crossAxisSpacing: 1,
                    mainAxisSpacing: 1,
                    crossAxisCount: colNb, // Nombre de colonnes 
                    children: [Text("aaaa"), Text("bbb"), Text("ccc")] // createTilesFromImage(colNb)
                    
                    )),
          ],
        ))
        ;
      }

  List<Widget> createTilesFromImage(int colNb) {
    print("creating tiles");
    Tile tile;
    List<Widget> res = <Widget>[];
    for(int i=0; i<colNb; i++){
      for(int j=0; j<colNb; j++){
        tile = Tile(image: image, alignment: Alignment(-1 + 2 * j.toDouble() /  colNb.toDouble(), -1 + 2 * i.toDouble() / colNb.toDouble()));
        
        res.add(InkWell(
            child: tile.croppedImageTile(1 / colNb),
            onTap: () {
              print("tapped on tile $i $j");
            },
        ));
      }
    }
    print("finished creating tiles");
    print(res);

    return res
    ;
  }
}
